/*****************************************************************************
This is a Pattern Recognition program
Copyright (C) 2006  Elmar Sack

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Elmar.Sack@mnet-online.de
*****************************************************************************/

/* global prototypes *******************************************************/
int session_to_untrained(pic_def sessimg);
pic_def convert_pic_dbl(pic_dbl pic);
void dump_pic_dbl(pic_dbl pic, char *fname);
void dump_pic_def(pic_def src, char *name, area_def clp, int x_offset, 
		  int y_offset, int verbose, PNM_FORMAT forcef);
img_typ read_pnm_file(char *input, int *mgv, int verbose);
void pnm_to_bitmap(img_typ *pic, int mgv, char *filename, int histo_thold, 
		   img_typ *ses, hst_def *grey_hist, hst_def *th_hist);
void verify_bitmap(pic_def src, area_def clp, int x_offset, int y_offset);
void copy_bmps(pic_def src, pic_def dst, area_def cut, int sx, int sy, 
               int dx, int dy);
void copy_color(pic_def src, pic_def dst, area_def cut, int sx, int sy, 
                int dx, int dy);
void copy_bmp_to_matrix(pic_def src, double **dst, area_def cut, 
			int sx, int sy, int dx, int dy);
void copy_grey_to_color(pic_def src, pic_def dst, area_def cut, 
			col_def color, col_def backgnd, int sx, int sy, 
			int dx, int dy, int rawbit);
void convert_to_color(pic_def *ptmp, gboolean copy_bmp);
int xcopy_and_fit_pic(pic_def src, pic_def *dst);
int change_color(sector_def f, col_def from, col_def to, pic_def pic);
col_def random_color(int max, col_def *lst, int len, col_def defc);
col_def color_counter(double max, rgb_coef add, rgb_coef *color);
rgb_coef rgb_subdivision(int col_cnt);
void set_color(int len, col_def *dst, col_def value);
void set_bitmap(int len, PICT *dst, PICT value);
int set_pixel_masked(sector_def f, PICT mask, PICT to, pic_def pic,
		     gboolean trace_only);
int set_pixel(sector_def f, PICT from, PICT to, pic_def pic, int outside);
int unset_pixel(sector_def f, PICT from, PICT to, pic_def pic);
void level_patt(pic_def pic, int lvl);
int set_all_pixel(pic_def pic, PICT from, PICT to);
int rgb_to_grey(pic_def *pic, int verbose);
void grey_to_bitmap(int threshold, pic_def pic);
void add_color(pic_def src, pic_def dst, area_def cut, int sx, int sy, 
	       int dx, int dy);
void add_color_norm(pic_def src, pic_def dst, area_def cut, int sx, int sy, 
		    int dx, int dy);
void add_grey_norm(pic_def src, pic_def dst, area_def cut, int sx, int sy, 
		   int dx, int dy);
void add_grey(pic_def src, pic_def dst, area_def cut, int sx, int sy, int dx, 
	      int dy);
void add_bmps(pic_def src, pic_def dst, area_def cut, int sx, int sy, 
	      int dx, int dy);
pic_def bitmap_to_grey(pic_def pin);
pic_def grey_to_color(pic_def pin);
void add_bitmap_to_grey(pic_def src, pic_def dst, area_def cut, int sx, 
			int sy, int dx, int dy);
void add_bitmap_to_color(pic_def src, pic_def dst, area_def cut, int sx, 
			 int sy, int dx, int dy, col_def foreground_color);
PNM_FORMAT automatic_format(pic_def src, area_def clp, int x, int y, 
			    int rawbit);
PICT xget_pixel_or(sector_def f, pic_def pic);
PNM_FORMAT read_pnm_hdr(FILE *file, area_def *ar, int *mcv);
void draw_line(pic_def img, col_def bgnd, col_def fgnd, col_def fmsk, 
	       c_def start, c_def end);
pic_def histo_to_image(hst_def hist, int min_width , int height);
pic_def histos_to_image(hst_def histr, hst_def histg, hst_def histb, 
			col_def bgnd, col_def fgnd, int height);
void max_contrast_rgb(pic_def img);
/***************************************************************************/
