/*****************************************************************************
This is a Pattern Recognition program
Copyright (C) 2006  Elmar Sack

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Elmar.Sack@mnet-online.de
*****************************************************************************/

/* defines ******************************************************************/

#define nNDEBUG

#define XPLAB_PROGNAME "XPLAB"

#define PROGVERSION_0_3_1 "0.3.1"                             /* 08.10.2005 */
#define PROGVERSION_CURRENT PROGVERSION_0_3_1
#define PROGVERSION_0_3_0 "0.3.0"                             /* 20.03.2005 */
#define PROGVERSION_0_2_1 "0.2.1"                             /* 16.01.2005 */
#define PROGVERSION_0_2_0 "0.2.0"                             /* 01.01.2005 */
#define PROGVERSION_0_1_6 "0.1.6"                             /* 07.12.2004 */
#define PROGVERSION_0_1_5 "0.1.5"                             /* 16.10.2004 */
#define PROGVERSION_0_1_4 "0.1.4"                             /* 26.09.2004 */
#define PROGVERSION_0_1_3 "0.1.3"                             /* 10.09.2004 */
#define PROGVERSION_0_1_2 "0.1.2"                             /* 21.08.2004 */
#define PROGVERSION_0_1_1 "0.1.1"                             /* 26.07.2004 */
#define PROGVERSION_0_1_0 "0.1.0"                             /* 01.06.2003 */
#define PROGVERSION_0_0_5c "0.0.5c"                           /* 09.05.2003 */
#define PROGVERSION_0_0_5b "0.0.5b"                           /* 22.04.2003 */
#define DB_VERSION_CURRENT PROGVERSION_0_0_5b
#define PROGVERSION_0_0_5a "0.0.5a"                           /* 07.04.2003 */
#define PROGVERSION_0_0_5 "0.0.5"                             /* 22.03.2003 */
#define PROGVERSION_0_0_4 "0.0.4"
#define PROGVERSION_0_0_3 "0.0.3"
#define PROGVERSION_0_0_2 "0.0.2"

#define XPLAB_EMAIL	       "info@pattern-lab.de"
#define XPLAB_HOMEPAGE	       "http://www.pattern-lab.de/gui2.html"
#define XPLAB_COPYRIGHT_DATE   "1998-2006"
#define XPLAB_COPYRIGHT_AUTHOR "Elmar Sack"
#define XPLAB_COPYRIGHT_STRING "(C) " XPLAB_COPYRIGHT_DATE " " XPLAB_COPYRIGHT_AUTHOR
#define XPLAB_GRAPHIC_LIB      "GTK+ "

#define XPLAB_VERSION          XPLAB_PROGNAME " " PROGVERSION_CURRENT
#define XPLAB_REPLAY_MAGIC XPLAB_PROGNAME
#define XPLAB_REPLAY_SIGNATURE XPLAB_REPLAY_MAGIC " " PROGVERSION_CURRENT
#define POS_HDR                "# " XPLAB_VERSION "   Position List\n#\n"

#define GUI_OPTION_LIST "D:Yc:hv"
#define BATCH_OPTION_LIST "F"

#define CRF_HEADER      "*** Cluster Report File ***"
#define RPT_HEADER      "*** General Report File ***"
#define CFG_HEADER      "*** XPLAB Configuration ***"
#define NO_INPUT        "*** no input ***"
#define INPUT_DEFAULT   "*** default ***"
#define XPLAB_MAIN_LOG_HEADER XPLAB_VERSION "  *** Main Log ***  "
#define NO_TIMESTAMP    "(no timestamp wanted)"

#define XPLAB_TO_CODESET   "UTF-8"         /* Unicode used on Unix-style OS */
#define XPLAB_FROM_CODESET "ISO-8859-1"          /* West European languages */
#define UNIX_PATH_SEPARATOR '/'
#define XPLAB_PATH_LENGTH   2048
#define PICT            unsigned char
#define PICT_MAX        0xFF
#define FILE_EXT        "."             /* output filename separation value */
#define HLINE_COLOR     {(PICT)255, (PICT)0, (PICT)0}                /* red */
#define SLINE_COLOR     {(PICT)0, (PICT)200, (PICT)0}              /* green */
#define RB_FRAME_COLOR  {(PICT)0, (PICT)0, (PICT)255}               /* blue */
#define PATTERN_FAIL_COLOR {(PICT)255, (PICT)200, (PICT)200}   /* light red */
#define PATTERN_GOOD_COLOR {(PICT)155, (PICT)255, (PICT)155} /* light green */
#define MRB_FRAME_COLOR {(PICT)0, (PICT)200, (PICT)255}       /* light blue */
#define FGND_COLOR      {(PICT)0, (PICT)255, (PICT)0}              /* green */
#define XPM_COLOR_ICON_BGND       "CC00CC00FFFF"  
#define XPM_COLOR_ICON_FGND       "000000000000"  
#define XPM_COLOR_ICON_FILL_READ  "0000FFFF0000"  
#define XPM_COLOR_ICON_FILL_WRITE "FFFF00000000"  
#define FILE_TRAINING_SESSION ".xplab_session"    /* file extension session */
#define FILE_TRAINED    ".trained"        /* file extension trained pattern */
#define FILE_TO_TRAIN   ".to_train"       /* trained NB erased              */
#define FILE_REPLAY     ".xrpl"           /* raw Recognition File           */
#define FILE_REPORT     ".rpt"            /* General Report File            */
#define FILE_CLS        ".crf"            /* Cluster Report File            */
#define FILE_TXT        ".txt"            /* Recognition File               */
#define FILE_CHN_COL    ".tile.col"       /* colored chain list image       */
#define FILE_CHN_LST    ".tile."          /* chain images                   */
#define FILE_CHN_TMP    ".tile.tmp."      /* temporary image                */
#define SCREEN_DUMP     "screen_dump"     /* screen dump                    */
#define XPLAB_RECALL_LOGNAME_EXT   ".txt"                        /* recall */
#define XPLAB_REPLAY_LOGNAME_EXT   ".replay.txt"                 /* replay */
#define XPLAB_REPLAY_LOGNAME_DEFAULT "xplab_replay"
#define SESSION_FNAME_DEFAULT "xplab_training"
#define REPLAY_FNAME_DEFAULT "xplab_replay"
#define REPORT_FNAME_DEFAULT "xplab_report"
#define DB_FNAME_DEFAULT     "xplab_default_db"
#define CFGNAME_DEFAULT      "xplab.cfg"       /* XPLAB configuration file */
#define BATCHNAME_DEFAULT    "xplab_batch.log"     /* XPLAB batch log File */
#define XPLAB_MAIN_LOGNAME_DEFAULT "xplab_main.log" /*output XPLAB log File */
#define XPLAB_MAIN_LOGRUN_DEFAULT "xplab_running.log"/*output XPLAB log File */

#define FILE_BCK_DEFAULT "~"         /* Backup of file                      */
#define OLD_VERSION_BCK ".XSAV"      /* Backup of old DB version            */
#define TEMP_PICLST     "xplab.tmp." /* temporary image name basic          */
#define RBNAME_DEFAULT  "rb."        /* output RB filename                  */
#define FOCUS_NAME_DEFAULT ".focus." /* output focus filename               */
#define TPSNAME_DEFAULT  ".tps."     /* output TPS filename                 */
#define NBNAME_DEFAULT  ".nb."       /* output NB filename                  */
#define CLASS_NAME_DEFAULT  ".class" /* output Class filename               */
#define CLASSCORE_DEFAULT "class_core." /* Class core filename              */
#define CORENAME_DEFAULT  "core."    /* output core filename                */
#define HSTNAME_DEFAULT ".gw"        /* output stem histogram filename      */
#define FFTNAME_DEFAULT ".fft."      /* output stem FFT filename            */
#define CLUSTER_DEFAULT ".cluster"   /* output stem cluster image filename  */
#define PEDIGREE_DEFAULT ".ped."     /* output pedigree image filename      */
#define DB_EXCERPT      ".db.exc"    /* excerpt DB in ASCII format          */
#define DOC_EXCERPT     ".doc.exc"   /* excerpt doc. def. in ASCII format   */
#define EXCERPT_DEFAULT ".excerpt"   /* excerpt in ASCII format             */
#define EXTRACT_DEFAULT ".extract"   /* extract DB                          */
#define NB_EXCERPT      ".nb.exc"    /* excerpt NB defin. in ASCII format   */
#define CHN_EXCERPT     ".chn.exc"   /* excerpt NB chain def. in ASCII      */

#define INFNAMD_DEFAULT "rule"       /* output separation File              */
#define INFNAMD_LHOLD   "#l"
#define INFNAMD_FORMAT(d) ((d) ? "%s." INFNAMD_DEFAULT ".%d" : \
                                 "%s." INFNAMD_DEFAULT "." INFNAMD_LHOLD)
#define INFNAMD_REM "(" INFNAMD_LHOLD " text line)"

#define WRDNAMH_DEFAULT "word"                    /* output histogram file */
#define LINNAMH_DEFAULT "line"                    /* output histogram file */
#define LINNAMH_IDHOLD  "#c"                                /* placeholder */
#define LINNAMH_LHOLD   "#l"                                /* placeholder */
#define LINNAMH_IHOLD   "#i"                                /* placeholder */
#define LINNAMH_FORMAT(d) ((d) ? "%s.%s.%d_%d" : "%s." LINNAMH_IDHOLD \
                                                   "." LINNAMH_LHOLD  \
                                                   "_" LINNAMH_IHOLD)
#define LINNAMH_REM "(" LINNAMH_IDHOLD " "                       \
                        LINNAMH_DEFAULT "/" WRDNAMH_DEFAULT ", " \
                        LINNAMH_LHOLD  " text line, "            \
                        LINNAMH_IHOLD  " iteration/group)"

#define XPLAB_IMG_BORDER_SIZE 5
#define XPLAB_SCRN_COVR 0.7
#define XPLAB_SLIDER_WIDTH 19
#define XPLAB_WIN_FRAME_WIDTH 4
#define XPLAB_IMG_EXTRA_SIZE 43

#define XP_NAME_EXT    ".XP."                      /* basic name extension */
#define DC_NAME_EXT    ".DC."                      /* basic name extension */
#define DC_EXT_1D      "1D."                       /* basic name extension */
#define DC_EXT_2D      "2D."                       /* basic name extension */
#define DC_MAX_AUTO      0x1F                 /* maximal automatic options */

#define DC_OPT_ORG_FILE       "o"                        /* file extension */
#define XP_OPT_ORG_MSG        "original"                 /* status message */
#define DC_OPT_ORG_DESC       "original input"       /* option description */

#define DC_OPT_BMP_FILE       "b"                        /* file extension */
#define DC_OPT_BMP_DESC       "bitmapped input"      /* option description */

#define DC_OPT_GV_FILE        "g"                        /* file extension */
#define DC_OPT_GV_DESC "grey value from RGB input"   /* option description */

#define DC_OPT_DOT_FILE       "d"                        /* file extension */
#define DC_OPT_DOT_DESC       "discarded pixel"      /* option description */

#define DC_OPT_CLEAN_FILE     "c"                        /* file extension */
#define XP_OPT_CLEAN_MSG      "binarized"                /* status message */
#define DC_OPT_CLEAN_DESC     "clean image used"     /* option description */

#define DC_OPT_MARKED_FILE    "T"                        /* file extension */
#define XP_OPT_MARKED_MSG     "training"                 /* status message */
#define DC_OPT_MARKED_DESC    "training image"       /* option description */

#define DC_OPT_NB_GOOD_FILE   "n"                        /* file extension */
#define DC_OPT_NB_GOOD_DESC   "recognized NB"        /* option description */

#define DC_OPT_RB_ALL_FILE    "a"                        /* file extension */
#define DC_OPT_RB_ALL_DESC \
              "recognized & unrecognized RB sectors" /* option description */

#define DC_OPT_RB_ALL_INV_FILE "A"                       /* file extension */
#define DC_OPT_RB_ALL_INV_DESC \
"recognized & unrecognized RB sectors (background inverted)" /* option des */

#define DC_OPT_RB_GOOD_FILE   "r"                        /* file extension */
#define DC_OPT_RB_GOOD_DESC "recognized RB sectors"  /* option description */

#define DC_OPT_RB_GOOD_INV_FILE "R"                      /* file extension */
#define DC_OPT_RB_GOOD_INV_DESC \
       "recognized RB sectors (background inverted)" /* option description */

#define DC_OPT_RB_FAIL_FILE   "u"                        /* file extension */
#define DC_OPT_RB_FAIL_DESC "unrecognized RB sectors"/* option description */

#define DC_OPT_RB_FAIL_INV_FILE "U"                      /* file extension */
#define DC_OPT_RB_FAIL_INV_DESC \
     "unrecognized RB sectors (background inverted)" /* option description */

#define DC_OPT_RB_FRAME_BMP_FILE "f"                     /* file extension */
#define XP_OPT_RB_FRAME_BMP_MSG  "RB frames"             /* status message */
#define DC_OPT_RB_FRAME_BMP_DESC "RB frames bitmap"  /* option description */

#define DC_OPT_RB_FRAME_RGB_FILE "F"                     /* file extension */
#define DC_OPT_RB_FRAME_RGB_DESC "RB frames color"   /* option description */

#define DC_OPT_MRB_FRAME_BMP_FILE "m"                    /* file extension */
#define DC_OPT_MRB_FRAME_BMP_DESC "MRB frames bitmap"/* option description */

#define DC_OPT_MRB_FRAME_RGB_FILE "M"                    /* file extension */
#define DC_OPT_MRB_FRAME_RGB_DESC "MRB frames color" /* option description */

#define DC_OPT_HLINE_BMP_FILE "l"                        /* file extension */
#define DC_OPT_HLINE_BMP_DESC "horizontal lines bitmap" /* option descript */

#define DC_OPT_HLINE_RGB_FILE "L"                        /* file extension */
#define DC_OPT_HLINE_RGB_DESC "horizontal lines color"  /* option descript */

#define DC_OPT_SLINE_BMP_FILE "s"                        /* file extension */
#define DC_OPT_SLINE_BMP_DESC \
"RB subdivision lines bitmap"/* (with recognition file) option description */

#define DC_OPT_SLINE_RGB_FILE "S"                        /* file extension */
#define DC_OPT_SLINE_RGB_DESC \
"RB subdivision lines color" /* (with recognition file) option description */

#define DC_OPT_PEST_FILE     "p"                         /* file extension */
#define DC_OPT_PEST_DESC \
"phase image: CCF of signal & TFs, fixed TF period"  /* option description */

#define DC_OPT_PEST_MAX_FILE "P"                         /* file extension */
#define DC_OPT_PEST_MAX_DESC \
 "period image: Maximum of CCF of signal & TFs"      /* option description */

#define DC_2D_KEY            "DC_2D"
#define DC_2D_REM            "documentation channel 2-D flags"
#define DC_BIT_EMPTY         0                              /* DC bit flag */
#define DC_BIT_BMP           1                              /* DC bit flag */
#define DC_BIT_ORG           (DC_BIT_BMP<<1)                /* DC bit flag */
#define DC_BIT_DOT           (DC_BIT_ORG<<1)                /* DC bit flag */
#define DC_BIT_CLEAN         (DC_BIT_DOT<<1)                /* DC bit flag */
#define DC_BIT_NB_GOOD       (DC_BIT_CLEAN<<1)              /* DC bit flag */
#define DC_BIT_RB_GOOD       (DC_BIT_NB_GOOD<<1)            /* DC bit flag */
#define DC_BIT_RB_FAIL       (DC_BIT_RB_GOOD<<1)            /* DC bit flag */
#define DC_BIT_RB_FRAME_BMP  (DC_BIT_RB_FAIL<<1)            /* DC bit flag */
#define DC_BIT_MRB_FRAME_BMP (DC_BIT_RB_FRAME_BMP<<1)       /* DC bit flag */
#define DC_BIT_HLINE_BMP     (DC_BIT_MRB_FRAME_BMP<<1)      /* DC bit flag */
#define DC_BIT_GV            (DC_BIT_HLINE_BMP<<1)          /* DC bit flag */
#define DC_BIT_RB_FRAME_RGB  (DC_BIT_GV<<1)                 /* DC bit flag */
#define DC_BIT_MRB_FRAME_RGB (DC_BIT_RB_FRAME_RGB<<1)       /* DC bit flag */
#define DC_BIT_HLINE_RGB     (DC_BIT_MRB_FRAME_RGB<<1)      /* DC bit flag */
#define DC_BIT_SLINE_BMP     (DC_BIT_HLINE_RGB<<1)          /* DC bit flag */
#define DC_BIT_SLINE_RGB     (DC_BIT_SLINE_BMP<<1)          /* DC bit flag */
#define DC_BIT_RB_GOOD_INV   (DC_BIT_SLINE_RGB<<1)          /* DC bit flag */
#define DC_BIT_RB_FAIL_INV   (DC_BIT_RB_GOOD_INV<<1)        /* DC bit flag */
#define DC_BIT_RB_ALL        (DC_BIT_RB_FAIL_INV<<1)        /* DC bit flag */
#define DC_BIT_RB_ALL_INV    (DC_BIT_RB_ALL<<1)             /* DC bit flag */
#define DC_BIT_PEST          (DC_BIT_RB_ALL_INV<<1)         /* DC bit flag */
#define DC_BIT_PEST_MAX      (DC_BIT_PEST<<1)               /* DC bit flag */

#define DC_PREFIX            "# "
#define DC_SUFFIX            "\n#\n"

#define DC_OPT_POS_CCF_FILE "c"                          /* file extension */
#define DC_OPT_POS_CCF_DESC "crosscorrelation function" /* option descript */

#define DC_OPT_POS_PAD_FILE "s"                          /* file extension */
#define DC_OPT_POS_PAD_DESC "zero padded signal"     /* option description */

#define DC_OPT_TFIN_FILE    "t"                          /* file extension */
#define DC_OPT_TFIN_DESC    "optimal testfunction"   /* option description */

#define DC_OPT_TFLAG_FILE   "l"                          /* file extension */
#define DC_OPT_TFLAG_DESC   "lagged testfunction"    /* option description */

#define DC_OPT_POS_FILE     "p"                          /* file extension */
#define DC_OPT_POS_DESC     "position list"          /* option description */

#define DC_OPT_POS_HPHASE_FILE "h"                       /* file extension */
#define DC_OPT_POS_HPHASE_DESC "H phase of position list" /* option descri.*/

#define DC_1D_KEY            "DC_1D"
#define DC_1D_REM            "documentation channel 1-D flags"
#define DC_BIT_POS_CCF       1                              /* DC bit flag */
#define DC_BIT_POS_PAD       (DC_BIT_POS_CCF<<1)            /* DC bit flag */
#define DC_BIT_TFIN          (DC_BIT_POS_PAD<<1)            /* DC bit flag */
#define DC_BIT_TFLAG         (DC_BIT_TFIN<<1)               /* DC bit flag */
#define DC_BIT_POS           (DC_BIT_TFLAG<<1)              /* DC bit flag */
#define DC_BIT_POS_HPHASE    (DC_BIT_POS<<1)                /* DC bit flag */
#define DC_MAX_1D_AUTO ((DC_BIT_POS_HPHASE<<1)-1) /* automatic 1-D options */

#define TPS_MAX        (1024*1024)
#define RB_MAX         (1024*1024*8)

#define TPSID_DEFAULT  "IDDEF"
#define TPSID_KEY      "TPS_ID"
#define TPSID_REM      "Trained Pattern Set IDentification"

#define PINPUT_KEY      "PInput"
#define PINPUT_REM      "file name path of image for recognition"

#define DBNAME_KEY      "DBName"
#define DBNAME_REM      "file name path of database for recognition"

#define THOLD_MIN       -1
#define THOLD_MAX       255
#define THOLD_DEFAULT   -1
#define THOLD_KEY       "Thold"
#define THOLD_REM       "image binarisation threshold, '-1' automatic"

#define MAXCOL_DEFAULT  80
#define RB_CHAIN        100                         /* planned amount of RB */

#define DC_STORE_DEFAULT 1
#define DC_STORE_MIN     0
#define DC_STORE_MAX     10
#define DC_STORE_KEY     "DCstore"
#define DC_STORE_REM     "number of images stored internally"

#define NB_BORDER_DEFAULT 1
#define NB_BORDER_MIN     0
#define NB_BORDER_MAX     99
#define NB_BORDER_KEY     "NB_Border"
#define NB_BORDER_REM     "border of dumped NB images"

#define LEVEL_MIN       (double)(0.0)
#define LEVEL_MAX       (double)(1.0)
#define LEVEL_DEFAULT   (double)(0.9)
#define LEVEL_KEY       "CVLevel"
#define LEVEL_REM       "correlation threshold"

#define BROKEN_LEVEL_MIN       LEVEL_MIN
#define BROKEN_LEVEL_MAX       LEVEL_MAX
#define BROKEN_LEVEL_DEFAULT   LEVEL_DEFAULT
#define BROKEN_LEVEL_KEY       "CVBroken"
#define BROKEN_LEVEL_REM       "correlation threshold for broken patterns"

#define CLUSTER_LVL_MIN (double)(0.5)
#define CLUSTER_LVL_MAX (double)(1.0)
#define CLUSTER_LVL_DEFAULT (double)(0.5)
#define CLUSTER_LVL_KEY "ClusterLvl"
#define CLUSTER_LVL_REM "minimal correlation threshold"

#define CLUSTER_STEP_MIN (double)(0.1)
#define CLUSTER_STEP_MAX (double)(0.5)
#define CLUSTER_STEP_DEFAULT (double)(0.1)
#define CLUSTER_STEP_KEY "ClusterStep"
#define CLUSTER_STEP_REM "correlation threshold decreasing step"

#define NNBMATCH_MIN     0                                    /* unit pixel */
#define NNBMATCH_MAX     10
#define NNBMATCH_DEFAULT 1 
#define NNBMATCH_KEY     "NNBmatch"
#define NNBMATCH_REM     "minimal NNB pixel matching degree"

#define OVERLAP_MIN     (double)(0.0)
#define OVERLAP_MAX     (double)(1.0)
#define OVERLAP_DEFAULT (double)(0.1)
#define OVERLAP_KEY     "Overlap"
#define OVERLAP_REM     "maximal allowed overlapping degree"

#define NB_LAP_MIN      (double)(0.0)
#define NB_LAP_MAX      (double)(1.0)
#define NB_LAP_DEFAULT  (double)(0.1)
#define NB_LAP_KEY      "NBLap"
#define NB_LAP_REM      "minimal allowed competing degree"

#define INTERLEAVE_MIN     (double)(0.0)
#define INTERLEAVE_MAX     (double)(0.5)
#define INTERLEAVE_DEFAULT (double)(0.1)
#define INTERLEAVE_KEY     "Interleave"
#define INTERLEAVE_REM     "horizontal step width in recognition phase"

#define MASKWEIGHT_MIN     0
#define MASKWEIGHT_MAX     100                    /* highhanded determined */
#define MASKWEIGHT_DEFAULT 1
#define MASKWEIGHT_KEY     "MSKweight"
#define MASKWEIGHT_REM     "mask weighting factor, '0' no weighting"

#define MBORDER_MIN      0                                   /* unit pixel */
#define MBORDER_MAX      10                       /* highhanded determined */
#define MBORDER_DEFAULT  1
#define MBORDER_KEY      "MBorder"
#define MBORDER_REM      "mask border size"

#define NBORDER_MIN      0                                   /* unit pixel */
#define NBORDER_MAX      10                       /* highhanded determined */
#define NBORDER_DEFAULT  1
#define NBORDER_KEY      "NBorder"
#define NBORDER_REM      "maximal allowed lag"

#define SYSPC_MIN      (double)(0.0)
#define SYSPC_MAX      (double)(1.0)
#define SYSPC_DEFAULT  (double)(0.5)
#define SYSPC_KEY      "SYSpc"
#define SYSPC_REM      "symbol spacing rule"

#define RGB_NORM_MIN     (double)(1.0/1000.0)
#define RGB_NORM_MAX     (double)1000.0
#define RGB_NORM_DEFAULT (double)(1.0/3.0)
#define RGB_NORM_KEY     "RGB_norm"
#define RGB_NORM_REM     "color to grey conversion"

#define CKERNEL_W       3              /* number of columns of 3 x 3 matrice */
#define CKERNEL_H       CKERNEL_W         /* number of rows of 3 x 3 matrice */
#define CKERNEL_SIZE    (CKERNEL_W*CKERNEL_H)              /*  3 x 3 matrice */
#define CKERNEL_MIN     0
#define CKERNEL_MAX     CKERNEL_SIZE
#define CKERNEL_NULL    {0,0,0, \
		 	 0,0,0, \
			 0,0,0}
#define CKERNEL_DEFAULT {1,2,1, \
		 	 2,0,2, \
			 1,2,1}
#define CKERNEL_KEY     "Ckernel"
#define CKERNEL_REM     "cluster kernel"

#define CHOLD_MIN       CKERNEL_MIN
#define CHOLD_MAX       CKERNEL_MAX*8
#define CHOLD_DEFAULT   2
#define CHOLD_KEY       "Chold"
#define CHOLD_REM       "cluster extension level"

#define CLUSTER_FORCE_DEFAULT 0
#define CLUSTER_FORCE_KEY     "Cforce"
#define CLUSTER_FORCE_REM     "force decreasing threshold"

#define REPLAY_WRITE_DEFAULT 0
#define REPLAY_WRITE_KEY     "Replay"
#define REPLAY_WRITE_REM     "write recognition file"

#define TRAINING_WRITE_DEFAULT 0
#define TRAINING_WRITE_KEY     "TrainSession"
#define TRAINING_WRITE_REM     "write trained/untrained images"

#define CLUSTER_WRITE_DEFAULT 0
#define CLUSTER_WRITE_KEY     "Cwrite"
#define CLUSTER_WRITE_REM     "generate images, last always generated"

#define DURATION_DEFAULT 0
#define DURATION_KEY     "Duration"
#define DURATION_REM     "run time calculation"

#define SUPPORT_DOTS_DEFAULT 0             /* don't support dots by default */
#define SUPPORT_DOTS_KEY     "Support_Dots"
#define SUPPORT_DOTS_REM     "dots in input image"

#define SUPPORT_DOTS_AUTO_DEFAULT 0        /* don't support dots by default */
#define SUPPORT_DOTS_AUTO_KEY "Support_Dots_Auto"
#define SUPPORT_DOTS_AUTO_REM "dots supported driven by DB"

#define RAISE_DEFAULT 0                   /* don't raise windows by default */
#define RAISE_KEY     "RaiseWindow"
#define RAISE_REM     "raise window after close"

#define TIPS_DEFAULT 1                          /* show tooltips by default */
#define TIPS_KEY     "ToolTips"
#define TIPS_REM     ""

#define OVERWRITE_IMAGE_DEFAULT 0
#define OVERWRITE_IMAGE_KEY     "Overwrite_Image"
#define OVERWRITE_IMAGE_REM     "erase trained patterns from input image after training"

#define SINGLE_LINE_DEFAULT 0
#define SINGLE_LINE_KEY     "Single_Line"
#define SINGLE_LINE_REM     "qualify RBs as single line container"

#define SINGLE_NB_DEFAULT 0
#define SINGLE_NB_KEY     "Single_NB"
#define SINGLE_NB_REM     "qualify RBs as single NB container"

#define BROKEN_NB_DEFAULT 0
#define BROKEN_NB_KEY     "Broken_NB"
#define BROKEN_NB_REM     "qualify RBs as broken NB container"

#define RENEW_METHOD_DEFAULT 0
#define RENEW_METHOD_KEY     "RenewLineSpace"
#define RENEW_METHOD_REM     "ignore line spacing method settings in DB"

#define DOMAIN_SUPPRESS_OTHERS 1  /* only spatial domain allowed in version */
#define DOMAIN_DEFAULT 0                              /* default is spatial */
#define DOMAIN_KEY     "Domain"
#define DOMAIN_REM     "correlation domain, spatial or frequency by FFT"

#define TIMESTAMP_DEFAULT 1
#define TIMESTAMP_KEY     "Timestamp" 
#define TIMESTAMP_REM     "timestamp in report file"

#define WRITEAUTO_DEFAULT 0
#define WRITEAUTO_KEY     "WriteAuto" 
#define WRITEAUTO_REM     "write main log automatically"

#define RAWBIT_DEFAULT  1
#define RAWBIT_KEY      "Rawbit" 
#define RAWBIT_REM      "PNM image output format, binary or ASCII"

#define SUBSTRB_DEFAULT "@"
#define SUBSTRB_KEY     "Subst_RB"
#define SUBSTRB_REM     "substitution symbol for failed RB recognition"

#define HISTO_WRITE_DEFAULT 0                              /* no histogram */
#define HISTO_WRITE_KEY     "Histo" 
#define HISTO_WRITE_REM     "write histograms"

#define SUBSTNB_DEFAULT "~"
#define SUBSTNB_KEY     "Subst_NB"
#define SUBSTNB_REM     "substitution symbol for failed NB recognition"

#define STATS_ICON_CONTRAST_DEF TRUE              /* default icon contrast */
#define STATS_ICON_CONTRAST_KEY "StatsIconContrast"
#define STATS_ICON_CONTRAST_REM "maximise icon contrast"

#define STATS_WIN_DEFACTV FALSE    /* definitions to all statistic windows */
#define STATS_WIN_DEFAULT 200
#define STATS_WIN_MIN     30
#define STATS_WIN_MAX     700
#define STATS_WIN_REM     "W x H"

#define STATS_IORG_KEY    "StatsImgOriginal"
#define STATS_IORG_REM    "original image"

#define STATS_ICOL_KEY    "StatsImgColor"
#define STATS_ICOL_REM    "color image"

#define STATS_IGRY_KEY    "StatsImgGrey"
#define STATS_IGRY_REM    "grey image"

#define STATS_IBMP_KEY    "StatsImgBitmap"
#define STATS_IBMP_REM    "bit-map image"

#define STATS_HRBS_KEY    "StatsHistoRBsize"
#define STATS_HRBS_REM    "RB size histogram"

#define STATS_HSLOPE_KEY  "StatsHistoSlope"
#define STATS_HSLOPE_REM  "slope histogram"

#define STATS_HCOL_KEY    "StatsHistoColor"
#define STATS_HCOL_REM    "color histogram"

#define STATS_HGRY_KEY    "StatsHistoGrey"
#define STATS_HGRY_REM    "grey histogram"

#define STATS_HBMP_KEY    "StatsHistoBMP"
#define STATS_HBMP_REM    "BMP histogram"

#define XPLAB_GTK2_RC_DEF "gtkrc2.xplab"   /* default Gtk resource file name */
#define XPLAB_GTK2_RC_KEY "GtkRcFile2"
#define XPLAB_GTK2_RC_REM "Gtk 2.0 resource file"

#define EMPTY_LINE_DEFAULT " "

#define TILE_DIV_DEFAULT 2          /* tile size wish of document partition */
#define TILE_DIV_MIN     1              /* document size partition multiple */
#define TILE_SIZE_MIN    100     /* document partition minimum pixel length */
#define EXTEND_RULE_STEP 2

#define ulong           unsigned long
#define BASELINE_INIT   0                            /* baseline init state */
#define ALIGNMENT_SIDE  1      /* !=0, bottom symbol border: seek direction */
#define ALIGNMENT_DIVR  4      /* >=1, period divisor                       */
#define RB_PURIFY_MULT  2               /* > 1, multiple of minimal NB area */
#define XV_DUMMY_STRING "# XV-Dummy-String :-(\n"
#define COMMENT_SIGN    '#'                             /* 1-character sign */
#define LINE_CONT_SIGN  '\\'                            /* 1-character sign */
#define FIRST_LINE_NBR  1                               /* first #line is 1 */
#define XPLAB_MENU_EXT  "..."                  /* window extension in menus */

#ifndef	FALSE
#define	FALSE	(0)
#endif

#ifndef	TRUE
#define	TRUE	(!FALSE)
#endif

#define XPLAB_READ_ACCESS  0
#define XPLAB_WRITE_ACCESS 1

#define XPLAB_DEF_CLASS_NAME   "***_undefined_***"
#define XPLAB_DEF_CLASS_TRANS  XPLAB_DEF_CLASS_NAME
#define XPLAB_DEF_CLASS_REMARK XPLAB_DEF_CLASS_NAME

#define PNMWIDTH             70            /* PNM definition, width max. 70 */
#define MAX_LEN_TPS_ID       256
#define MAX_LEN_CLASS_NAME   32
#define MAX_LEN_CLASS_TRANS  32
#define MAX_LEN_CLASS_COMMENT 256
#define MAXCHAR           80
#define DPI_DEF           300          /* units: [dpi]                      */
#define DPI_MIN           30           /* units: [dpi]                      */
#define DPI_MAX           (300*8)      /* units: [dpi]                      */
#define DINA4_WIDTH_CM    21.0         /* units: [cm]                       */
#define DINA4_HEIGHT_CM   29.7         /* units: [cm]                       */
#define INCH_CM           2.54         /* units: [cm]                       */
#define XPLAB_L_PHASE_MIN 1            /* units: [pixel] at least one pixel */
#define XPLAB_H_PHASE_MIN XPLAB_L_PHASE_MIN
#define XPLAB_L_PHASE_MAX ((int)((double)DPI_MAX*(double)DINA4_HEIGHT_CM/(double)INCH_CM))
#define XPLAB_H_PHASE_MAX XPLAB_L_PHASE_MAX
#define XPLAB_L_PHASE_DEF 18                /* units: [pixel]               */
#define XPLAB_H_PHASE_DEF XPLAB_H_PHASE_MIN /* units: [pixel]               */
#define MAXWIDTH        ((int)((double)DPI_DEF*(double)DINA4_WIDTH_CM/  \
                        (double)INCH_CM))
#define MAXHEIGHT       ((int)((double)DPI_DEF*(double)DINA4_HEIGHT_CM/ \
                        (double)INCH_CM))
#define MAXBLVL         7                      /* Max. for b-values (2^n-1) */
#define CONST_2PI       6.28318530717959       /* 2 * Pi, 360              */

#define XPLAB_COLOR_FOREGROUND {0,0,0}                       /* black pixel */
#define XPLAB_COLOR_IGNORED    {150,150,150}                  /* grey pixel */
#define XPLAB_COLOR_SELECTBL   {0,150,0}                     /* green pixel */
#define XPLAB_COLOR_SELECTED   {255,0,0}                       /* red pixel */
#define XPLAB_COLOR_RESERVED   {180,180,255}            /* light blue pixel */
#define XPLAB_COLOR_TRAINED    {0,0,255}                      /* blue pixel */
#define XPLAB_SIGN_BGD_IN      {255,255,160}     /* light yellow background */
#define XPLAB_SIGN_BGD_OUT     {255,255,255}            /* white background */

#define XPLAB_CLASS_NEW_COLOR {0, 0xFFFF,0xBEBE,0xBEBE}             /* pink */
#define XPLAB_CLASS_EXT_COLOR {0, 0xF0F0,0xF0F0,0xD0D0}     /* light yellow */
#define XPLAB_CLASS_FND_COLOR {0, 0xD6D6,0xE8E8,0xFFFF}       /* light blue */
#define XPLAB_CLASS_SEL_COLOR {0, 0xD6D6,0xFFFF,0xE8E8}      /* light green */
#define XPLAB_CLASS_CCF_COLOR {0, 0xD6D6,0xD6D6,0xD6D6}       /* light grey */
#define XPLAB_RED_COLOR       {0, 0xFFFF,0x0000,0x0000}              /* red */

#define XPLAB_TOOLTIPS_BGND   {0, 0xF0E5,0xE6E9,0x8C8B}      /* tips yellow */
#define XPLAB_TOOLTIPS_FGND   {0, 0x0000,0x0000,0x0000}      /* tips black  */

#define P1_FORMAT       "%d "
#define P3_FORMAT       "%d %d %d "
#define P6_FORMAT       "%c%c%c"
#define SEP_SR1        -1                             /* distance mark, < 0 */
#define SEP_SR2        -2                             /* distance mark, < 0 */
#define SEP_WMV        -3                             /* distance mark, < 0 */

#define NO_STRING      -1                /* status entry recycling list < 0 */
#define BAD_STRING     -2                /* status entry recycling list < 0 */

#define SUBCLS_FLAG    -1                         /* invalid class flag < 0 */
#define SUBSTRB_FLAG   -1                       /* RB substitution flag < 0 */
#define SUBSTNB_FLAG   -2                       /* NB substitution flag < 0 */
#define SUBSTUC_FLAG   -3                      /* unsure candidate flag < 0 */
#define SKIP_ZERO       0

#define UNIPOLAR_MAX   1.0                /* unipolar signal value settings */
#define UNIPOLAR_MIN   0.0                /* unipolar signal value settings */

#define XPLAB_COMBO_STORE_COLUMN_TXT 0 /* combo store column containing history strings */
#define XPLAB_MAX_TPS  1000           /* maximal number of test pattern sets */
#define XPLAB_MEDIA_ENTRY_LENGTH 20
#define XPLAB_TPS_ID_ENTRY_LENGTH 30
#define XPLAB_CLASS_ENTRY_LENGTH 30 
#define XPLAB_HISTORY_LENGTH 10                            /* history length */
#define XPLAB_STRING_ZERO_LENGTH        1
#define XPLAB_STRING_CONVERSION_FAILED  2
#define XPLAB_STRING_TRUNCATED          3
#define XPLAB_STRING_CONVERSION_SUCCESS 4
#define XPLAB_STRING_CONVERSION_TPS_ID  5
#define XPLAB_STRING_CONVERSION_TPS_ID_MSG  "TPS ID already used"
#define XPLAB_STRING_CONVERSION_SUCCESS_MSG "string OK"
#define XPLAB_STRING_TRUNCATED_MSG          "string truncated"
#define XPLAB_STRING_CONVERSION_FAILED_MSG  "string conversion failed"
#define XPLAB_STRING_ZERO_LENGTH_MSG        "string is empty"
#define XPLAB_STRING_WITHOUT_CHANGES 0
#define XPLAB_STRING_WITH_CHANGES    1
#define XPLAB_STRING_NOT_USABLE      2
#define XPLAB_ATTRIBUTES_PARSING_SUCCESS_CHANGED "attribute parsing succeeded with corrections"
#define XPLAB_ATTRIBUTES_PARSING_SUCCESS         "attribute parsing succeeded"
#define XPLAB_ALIGNMENT_CONVERSION_SUCCESS_MSG   "ALIGNMENT set OK"
#define XPLAB_ALIGNMENT_CONVERSION_FAILED_MSG    "ALIGNMENT set failed"
#define XPLAB_DPI_CONVERSION_SUCCESS_MSG         "DPI set OK"
#define XPLAB_DPI_CONVERSION_CORRECTED_MSG       "DPI set corrected"
#define XPLAB_METHOD_CONVERSION_SUCCESS_MSG      "METHOD set OK"
#define XPLAB_METHOD_CONVERSION_FAILED_MSG       "METHOD set failed"
#define XPLAB_L_PHASE_CONVERSION_SUCCESS_MSG     "L Phase set OK"
#define XPLAB_L_PHASE_CONVERSION_CORRECTED_MSG   "L Phase set corrected"
#define XPLAB_H_PHASE_CONVERSION_SUCCESS_MSG     "H Phase set OK"
#define XPLAB_H_PHASE_CONVERSION_CORRECTED_MSG   "H Phase set corrected"
#define XPLAB_DIALOG_TO_BE_WRITTEN               "dialog to be written"
#define XPLAB_TPS_ID_PARSING_ERROR               "TPS ID parsing error"
#define XPLAB_TPS_ID_CONVERSION_SUCCESS_MSG      "TPS ID set OK"
#define XPLAB_CLASS_PARSING_ERROR                "CLASS parsing error"
#define XPLAB_CLASS_NAME_CONVERSION_SUCCESS_MSG  "CLASS set OK"
#define XPLAB_CLASS_NAME_PARSING_ERROR "CLASS parsing error: class name already in use"
#define XPLAB_CLASS_TRANSLATION_CONVERSION_SUCCESS_MSG "TRANSLATION set OK"
#define XPLAB_CLASS_TRANSLATION_PARSING_ERROR    "TRANSLATION parsing error"
#define XPLAB_CLASS_COMMENT_CONVERSION_SUCCESS_MSG "COMMENT set OK"
#define XPLAB_CLASS_COMMENT_PARSING_ERROR        "COMMENT parsing error"
#define XPLAB_CLASS_PRINTABLE_CONVERSION_SUCCESS_MSG "PRINTABLE set OK"
#define XPLAB_CLASS_PRINTABLE_PARSING_ERROR      "PRINTABLE parsing error"
#define XPLAB_CLASS_PRINTABLE_NB_WARNING  "WARNING: PRINTABLE not TRUE for NB"
#define XPLAB_CLASS_PRINTABLE_CNB_WARNING "WARNING: PRINTABLE not TRUE for CNB"
#define XPLAB_CLASS_FIXED_CONVERSION_SUCCESS_MSG "FIXED set OK"
#define XPLAB_CLASS_FIXED_PARSING_ERROR          "FIXED parsing error"
#define XPLAB_NO_IMAGE_MSG                       "no image loaded"

#define XPLAB_INIT_AUX_CAND_DEF 0
#define XPLAB_INIT_AUX_NB_DEF   0
#define XPLAB_INIT_AREA  -1                       /* impossible area value */
#define XPLAB_INIT_HASH_ID 0x1ABC0000        /* signed hash identification */

#define XPLAB_MAGN_X1_NAME  "x1"
#define XPLAB_MAGN_X1_VALUE 1.0                            /* don't change */
#define XPLAB_MAGN_X2_NAME  "x2"
#define XPLAB_MAGN_X2_VALUE 2.0
#define XPLAB_MAGN_X4_NAME  "x4"
#define XPLAB_MAGN_X4_VALUE 4.0
#define XPLAB_MAGN_D2_NAME  "/2"
#define XPLAB_MAGN_D2_VALUE 0.5
#define XPLAB_MAGN_D4_NAME  "/4"
#define XPLAB_MAGN_D4_VALUE 0.25

#define XPLAB_ENTRY_LEN_FLOAT 60
#define XPLAB_ENTRY_LEN_INT1  20
#define XPLAB_ENTRY_LEN_INT2  25
#define XPLAB_ENTRY_LEN_INT3  30
#define XPLAB_ENTRY_LEN_CHARS 100

#define XPLAB_STATISTIC_HISTO_HEIGHT PICT_MAX+1

#define XPLAB_RC_MAIN_LOG   "xplab-main-log"
#define XPLAB_RC_RECALL_LOG "xplab-recall-log"

#define STSFY_GCC(udat) udat=udat                          /* satisfy GCC */

#define XPMOD8(x)       (((x)%8)  ? (((x)>>3)+1) : ((x)>>3))
#define XPMOD32(x)      (((x)%32) ? (((x)>>5)+1) : ((x)>>5))
#define XPMIN(x,y)      (((x) < (y)) ? (x) : (y))
#define XPMAX(x,y)      (((x) > (y)) ? (x) : (y))
#define MAX_RB(x,y)     (((x) * (y) + 3) >> 2)

#ifndef vsscanf
int vsscanf(const char *str, const char *format, va_list ap);
#endif

#define XPOW2(x,y)      do {                                           \
                          int ipow2 = 2;                               \
                          y = MAX(2, x);                               \
                          while(ipow2 < y) {                           \
                            ipow2 <<= 1;                               \
                          }                                            \
                        y = ipow2;                                     \
                        } while(0)

#define XPSWAP(z,x,y)   do {                                           \
	                   (z) = (x);                                  \
   	                   (x) = (y);                                  \
	                   (y) = (z);                                  \
                        } while(0)

#define P_ALLOC_ENROLL(ptr)                                            \
do {                                                                   \
  if (ptr) {                          /* zero pointer not supported */ \
    int aloc_i;                                                        \
    for (aloc_i = 0; aloc_i < P_alloc_size; aloc_i++) {     /* test */ \
      assert(P_alloc[aloc_i] != (ptr));      /* allocated only once */ \
    }                                                                  \
    if (P_alloc_size++) {                   /* expand pointer array */ \
      P_alloc = (void *)realloc(P_alloc, P_alloc_size*sizeof(void *)); \
    }                                                                  \
    else {                                                             \
      P_alloc = (void *)calloc(P_alloc_size, sizeof(void *));          \
    }                                                                  \
    assert(P_alloc);                                                   \
    P_alloc[P_alloc_size-1] = (ptr);              /* enroll pointer */ \
    if (P_print_pointer) printf("DEBUG: alloc %p  %s  %d\n",(void*)ptr,\
                                __FILE__, __LINE__);                   \
  }                                                                    \
} while(0)

#define P_ALLOC_OFF(ptr)                                               \
do {                                                                   \
  if (ptr) {                          /* zero pointer not supported */ \
    int aloc_j, aloc_found = 0;                                        \
    assert(P_alloc);                            /* entry must exist */ \
    for (aloc_j = 0; aloc_j < P_alloc_size; aloc_j++) {                \
      if (P_alloc[aloc_j] == (ptr)) {                                  \
        aloc_found = 1;                                                \
        P_alloc_size--;                                                \
        if (!P_alloc_size){                                            \
          free(P_alloc);                                               \
	  P_alloc = 0;                                                 \
          break;                                     /* empty array */ \
        }                                                              \
        if (aloc_j < P_alloc_size) {                                   \
          P_alloc[aloc_j] = P_alloc[P_alloc_size];                     \
        }                                                              \
        P_alloc = (void*)realloc(P_alloc, P_alloc_size*sizeof(void*)); \
        break;                        /* allocation freed only once */ \
      }                                                                \
    }                                                                  \
    assert(aloc_found);                                     /* test */ \
    if (P_print_pointer) printf("DEBUG: freed %p  %s  %d\n",(void*)ptr,\
                                __FILE__, __LINE__);                   \
  }                                                                    \
} while(0)

#define CALLOC(typ,siz,ptr)                                            \
                do {assert(siz>0);                                     \
                    assert(!(ptr));                                    \
                    ptr = (typ *) calloc((siz), sizeof(typ));          \
                    assert(ptr);                                       \
                    P_malloc_free++;                                   \
                    if (P_debug) P_ALLOC_ENROLL(ptr);                  \
                   } while(0)

#define REALLOC(typ,siz,ptr)                                           \
                 do {                                                  \
                   void *aloc_old_ptr = ptr;                           \
                   assert(siz>0);/* 0 would be allowed: P_malloc_free--*/\
                   assert(ptr);/* 0 would be allowed: P_malloc_free++*/\
                   ptr = (typ *) realloc(ptr,(siz)*sizeof(typ));       \
                   assert(ptr);     /* 0 would be allowed */           \
                   if (P_debug) {                                      \
                     if (aloc_old_ptr != (ptr)) {                      \
                       P_ALLOC_OFF(aloc_old_ptr);                      \
                       P_ALLOC_ENROLL(ptr);                            \
                     }                                                 \
                   }                                                   \
                 } while(0)

#define FREEMEM(ptr)    do {                                           \
                          if (ptr) {                                   \
                            if (P_debug) P_ALLOC_OFF(ptr);             \
                            free(ptr);                                 \
                            ptr = 0;                                   \
                            P_malloc_free--;                           \
                          }                                            \
                        } while(0)

#define AREA_TO_SECTOR(ar,sec)                                         \
                 do {(sec).line.start   = 0;                           \
                     (sec).line.end     = ar.height - 1;               \
                     (sec).column.start = 0;                           \
                     (sec).column.end   = ar.width - 1;                \
                    } while(0)

#define INTERVAL_SIZE(ival) (((ival).end) - ((ival).start) + 1)

#define SECTOR_TO_AREA(sec,ar)                                         \
                 do {ar.width = INTERVAL_SIZE(sec.column);             \
                     ar.height = INTERVAL_SIZE(sec.line);              \
                    } while(0)

#define AREA_SIZE(ar) (((ar).width) * ((ar).height))

#define SECTOR_SIZE(sec)                                               \
              (INTERVAL_SIZE((sec).column) * INTERVAL_SIZE((sec).line))

#define WITHIN_INTERVAL(x,ival) (((x)>=(ival).start) && ((x)<=(ival).end))

#define WITHIN_SECTOR(x,y,sec) (WITHIN_INTERVAL(x,(sec).column) &&     \
                                WITHIN_INTERVAL(y,(sec).line))

#define A_WITHIN_B_SECTOR(a,b) ((a).line.start   >= (b).line.start   && \
                                (a).line.end     <= (b).line.end     && \
                                (a).column.start >= (b).column.start && \
                                (a).column.end   <= (b).column.end)

#define ASSERT_SECTOR(sec,iar) {      /* assert sector within image */   \
                                  assert((sec).line.start >= 0);         \
                                  assert((sec).line.end < (iar).height); \
                                  assert((sec).column.start >= 0);       \
                                  assert((sec).column.end < (iar).width);\
                                }

#define TRIM_SECTOR(sec,iar) {        /* trim sector to image borders */   \
             (sec).line.start   = XPMAX((sec).line.start, 0);              \
             (sec).line.end     = XPMIN((sec).line.end, (iar).height - 1); \
             (sec).column.start = XPMAX((sec).column.start, 0);            \
             (sec).column.end   = XPMIN((sec).column.end, (iar).width - 1);\
           }

#define RING_BUFFER_INDEX(idx,ring_size) {       /* ring buffer index */ \
                           if ((idx) < 0) {                              \
                             (idx) = (ring_size)-1;                      \
                           }                                             \
                           else if ((idx) >= (ring_size)) {              \
                             (idx) = 0;                                  \
			   }                                             \
                         }
 
#define ADD_COLOR(src,dst)                              \
                 do {(dst).r = ((dst).r + (src).r)/2;   \
	             (dst).g = ((dst).g + (src).g)/2;   \
	             (dst).b = ((dst).b + (src).b)/2;   \
                    } while(0)

#define XPLAB_VA_LIST(vformat,out_string)                                   \
     do  {                                                                  \
       int     dmac, dsize = MAXCHAR;                                       \
       va_list ap;                                                          \
                                                                            \
       assert(out_string == NULL);                                          \
       CALLOC(char, dsize, out_string);                                     \
                                                                            \
       while (1) {                                       /* man vsnprintf */\
         va_start(ap, vformat);                                             \
         dmac = g_vsnprintf(out_string, dsize, vformat, ap);                \
         va_end(ap);                                                        \
                                                                            \
         if ((dmac > -1) && (dmac < dsize)) { /* allocation is big enaugh */\
           break;                                                           \
         }                                                                  \
                                                                            \
         if (dmac > -1) {                                                   \
           dsize = dmac+1;                                                  \
         }                                                                  \
         else {                                                             \
           dsize *= 2;                                                      \
         }                                                                  \
                                                                            \
         REALLOC(char, dsize, out_string);                                  \
       }                                                                    \
     } while(0)

typedef enum {
  XPLAB_IDX_NONE = -1,                           /* impossible index value */
  XPLAB_IDX_TPS,
  XPLAB_IDX_CLS,
  XPLAB_IDX_NB
} XPLAB_INDEX_TYPE;

typedef enum {
  XPLAB_DB_RO,                           /* XPLAB db read only access      */
  XPLAB_DB_RW                            /* XPLAB db read and write access */
} XPLAB_DB;

typedef enum {
  CONTOUR_UNDEF,
  CONTOUR_INNER_EXC,         /* inner contour exclusiv (hole is background) */
  CONTOUR_OUTER_INC       /* outer contour inclusiv (pattern is foreground) */
} CONTOUR_TYPE;           /* contour types if contour pixels are foreground */

typedef enum {
   BACKGROUND           = ((PICT)0x00000000),              /* white (fixed) */
   FOREGROUND           = ((PICT)0x00000001),              /* black (fixed) */
   CONTOURSTART         = ((PICT)0x00000002),              /* contour start */
   CONTOUREND           = ((PICT)0x00000004),              /* contour end   */
   XPLAB_RESERVED_PIXEL = ((PICT)0x00000008),
   XPLAB_SELECTED_PIXEL = ((PICT)0x00000010),
   XPLAB_IGNORED_PIXEL  = ((PICT)0x00000020),
   XPLAB_SELECTBL_PIXEL = ((PICT)0x00000040),
   XPLAB_TRAINED_PIXEL  = ((PICT)0x00000080)
} PIXEL_KEY;                   /* values must be bit-exclusiv and char wide */

enum {
  OPT_FRB_BIT = 2,                               /* data source with frames */
  OPT_MRB_BIT = 4,                               /* data source with frames */
  OPT_HLINE_BIT = 8,                              /* data source with lines */
  FLAG_MAX
} DOCU_KEY;                                  /* values must be bit-exclusiv */

typedef enum {
  PATTERN_ALL,                         /* unrecognized & recognized pattern */
  PATTERN_REC,                                        /* recognized pattern */
  PATTERN_UREC                                      /* unrecognized pattern */
} PATTERN_ATT;

typedef enum {
  SRC_VALID_INCOMPLETE,                   /* source is valid but incomplete */
  SRC_VALID_COMPLETE,                       /* source is valid and complete */
  SRC_INVALID                     /* source is invalid, for other consumers */
} SRC_IS;

typedef enum {
  DC_OPTION_1D,                                                 /* 1-D data */
  DC_OPTION_2D                                                  /* 2-D data */
} DC_OPTION_TYPE;

typedef enum {
   NBH4C,
   NBH4X,
   NBH8
} NBH;                                                     /* Neighborhood */

typedef enum {
   FIRST_SIGNAL_TYPE,
   NRZ,
   NRZI,
   UNIPOLAR,
   POLAR,
   ZERO_MEAN,
   LOWER_PHASE,
   LAST_SIGNAL_TYPE
} SIGNAL_TYPE;

typedef enum {
  CLUSTER_NB_NEW = 1,
  CLUSTER_NB_OLD = 2
} CLUSTER_NB_BIT;                                         /* bit exclusive */

#define CLUSTER_NB_KEY "C_DB_update" 
#define CLUSTER_NB_REM "how to update new DB"

typedef enum {
   RB_CHAIN_DEFAULT    = 0,
   RB_CHAIN_DUMP_COLOR = 1,
   RB_CHAIN_DUMP_TILES = 2,
   RB_CHAIN_USE        = 4
} RB_CHAIN_BIT;            /* bit exclusive */

#define RB_CHAIN_KEY "RB_Chain" 
#define RB_CHAIN_REM "RB chains"

typedef enum {
   RB_STATUS_INIT,         /* initial value            */
   RBN,                    /* neighbor RB              */
   LEARNED,                /* RB learned               */
   NOT_LEARNED,            /* RB not learned           */
   BOOKED,                 /* RB booked                */
   TOUCHED,                /* RB touched               */
   INVALID,                /* RB invalid               */
   PIC_DUMPED,             /* image dumped to disc     */
   CHAIN                   /* RB chain member          */
} RB_STATUS;

typedef enum {
  UDEFLINE,                /* undefined, not printable         */
  UNDERLINE,               /* below baseline, descent          */
  BASELINE,                /* baseline                         */
  MIDDLELINE,              /* middle line                      */
  UPPERLINE,               /* top line, only ascent            */
  ALIGNMENT_MAX            /* maximal enumeration              */
} ALIGMNT;                 /* NB placed relative to baseline   */

typedef enum {
   PNM_FORMAT_UNDEF,
   PNM_FORMAT_ORIGINAL,   /* query key */
   PNM_FORMAT_MIXED,
   P1,                    /* ascii  PBM (Bitmap)  (ISO 8859-1) PNM          */
   P2,                    /* ascii  PGM (Greymap) (ISO 8859-1) PNM          */
   PXPLAB2,               /* ascii  PGM (session) (ISO 8859-1) extended PNM */
   P3,                    /* ascii  PPM (RGB)     (ISO 8859-1) PNM          */
   P4,                    /* binary PBM (Bitmap)               PNM          */
   P5,                    /* binary PGM (Greymap)              PNM          */
   PXPLAB5,               /* binary PGM (session)              extended PNM */
   P6                     /* binary PPM (RGB)                  PNM          */
} PNM_FORMAT;                                       /* extended format spec */

typedef enum {
  STATS_FORMAT_UNDEF,                                  /* first entry       */
  STATS_IMAGE_ORIGINAL,                                /* original image    */
  STATS_IMAGE_COLOR,                                   /* colored image     */
  STATS_IMAGE_GREY,                                    /* grey-valued image */
  STATS_IMAGE_BMP,                                     /* bit-mapped image  */
  STATS_HISTO_COLOR,                                   /* histogram color   */
  STATS_HISTO_GREY,                                    /* histogram grey    */
  STATS_HISTO_BMP,                                     /* histogram BMP     */
  STATS_HISTO_RBS,                                     /* histogram RB size */
  STATS_HISTO_SLOPE,                                   /* histogram slope   */
  STATS_ICON_CONTRAST_MAX,                        /* maximise icon contrast */
  STATS_FORMAT_MAX                                     /* last entry        */
} STATS_FORMAT;                         /* definition of statistics formats */

typedef enum {
  D_UP,
  D_DOWN,
  D_LEFT,
  D_RIGHT
} DIR_STATUS;

typedef enum {
  MINIMUM_COLORS,
  MAXIMUM_COLORS,
  RANDOM_COLORS
} COLORING;

#define COLORING_METHOD RANDOM_COLORS

typedef enum {
  REPORT_WRITE_DEFAULT = 0,                              /* default report */
  REPORT_WRITE_TERSE   = 1,                                /* terse report */
  REPORT_WRITE_RBS     = 2,                             /* report with RBS */
  REPORT_WRITE_NOT     = 4                                    /* no report */
} REPORT_WRITE_FLAG;                                      /* bit exclusive */

#define REPORT_WRITE_KEY "Report" 
#define REPORT_WRITE_REM "write general report"

typedef enum {
  VERBOSE_FIRST,
  BE_QUIET,                            /* only unresolvable error messages */
  VERBOSE_DEFAULT,                                        /* disc accesses */
  VERBOSE_NORMAL,                                /* some informal messages */
  VERBOSE_LOT,                                           /* debug messages */
  VERBOSE_LAST
} VERBOSE;                                     /* STDOUT: verbose or quiet */

#define VERBOSE_KEY "Verbose"
#define VERBOSE_REM "verbose messages"

typedef enum {
  MATCHING_METHOD_FIRST,                     /* automatic method selection */
  MATCHING_METHOD_1,                              /* basic matching method */
  MATCHING_METHOD_2,                     /* broken pattern matching method */
  MATCHING_METHOD_LAST
} MATCHING_METHOD;


typedef enum {
  METHOD_FIRST = 0,
  OVERLAPPING  = 1,                                          /* keep value */
  LINE_SPACING = 2,                                          /* keep value */
  METHOD_LAST  = 3
} INLINE_METHOD;

#define METHOD_AUTO_STRING  "(DB settings)"
#define OVERLAPPING_STRING  "OVERLAPPING"
#define LINE_SPACING_STRING "LINE SPACING"

#define LINE_METHOD_KEY "Method"
#define LINE_METHOD_REM "forced line detection"

#define XPLAB_IS_METHOD(method) (((method) == OVERLAPPING) ||    \
                                 ((method) == LINE_SPACING))

typedef enum {
  NOT_REGISTERED      = -1,                         /* negative index flag */
  REGISTERED_NEGATIVE = -2,                         /* negative index flag */
  REGISTERED_POSITIVE = -3,                         /* negative index flag */
  REGISTERED_POSITIVE_IDENTIC = -4,                 /* negative index flag */
  REGISTERED_POSITIVE_RESTRICT = -5,                /* negative index flag */
  REGISTERED_INHIBIT  = -6,                         /* negative index flag */
  REGISTERED_IDENTIC  = -7,                         /* negative index flag */
  REGISTERED_RESTRICT = -8                          /* negative index flag */
} REGISTER_INDEX;

typedef enum {
  INHIBITED_FALSE,
  INHIBITED_TRUE,
  INHIBITED_BY_MISALIGNMENT,
  INHIBITED_BY_NB_ALIGNMENT,
  INHIBITED_BY_CNB
} INH_FLAG;

typedef enum {
  XPLAB_PARSE_STAT_DEF = 0,                                /* don't change */
  XPLAB_PARSE_STAT_NEW = 1,                                /* bit exlusive */
  XPLAB_PARSE_STAT_EXT = 2,                                /* bit exlusive */
  XPLAB_PARSE_STAT_SEL = 4,                                /* bit exlusive */
  XPLAB_PARSE_STAT_FND = 8,                                /* bit exlusive */
  XPLAB_PARSE_STAT_OLD = 16,                               /* bit exlusive */
  XPLAB_PARSE_STAT_CCF = 32                                /* bit exlusive */
} PARSE_STAT;

enum {
  OVL_NOT,
  OVL_PART,
  OVL_A_IN_B,
  OVL_B_IN_A
} OVL_FLAG;

typedef enum {                                               /* keep order */
  BATCH_PHASE_NO,
  BATCH_PHASE_MATCHING,
  BATCH_PHASE_CLUSTER,
  BATCH_PHASE_RB_CHAIN
} BATCH_PHASE;

#define BATCH_PHASE_KEY "BatchJob"
#define BATCH_PHASE_REM "batch job phase"

typedef enum {
  BATCH_LOG_NO,
  BATCH_LOG_OVWRT,
  BATCH_LOG_APPND
} BATCH_LOG;

#define BATCH_LOG_KEY "BatchLog" 
#define BATCH_LOG_REM "batch job log"

typedef enum {
  STATE_IS_INIT,      /* data contains no info, no dynamic allocation made */
  STATE_IS_DEFINED_PARTIALLY,                   /* some data contains info */
  STATE_IS_DEFINED_FULLY                         /* all data contains info */
} DATA_STATE;                                     /* state of complex data */

#define GTK_CONVENTION_WIDGET_EVENT_RTS_GBOOLEAN GtkWidget *widget, GdkEvent *event, gpointer user_data
#define GTK_CONVENTION_WINDOW_DELETE_RTS_GBOOLEAN GtkWidget *widget, GdkEvent *event, gpointer user_data
#define GTK_CONVENTION_DIALOG_RTS_GBOOLEAN GtkWidget *widget, GdkEvent *event, gpointer user_data
#define GTK_CONVENTION_MENUITEM_RTS_VOID GtkMenuItem *menuitem, gpointer user_data
#define GTK_CONVENTION_CHECKMENUITEM_RTS_VOID GtkCheckMenuItem *checkmenuitem, gpointer user_data
#define GTK_CONVENTION_BUTTON_RTS_VOID GtkButton *button, gpointer user_data
#define GTK_CONVENTION_TOGGLEBUTTON_RTS_VOID GtkToggleButton *togglebutton, gpointer user_data
#define GTK_CONVENTION_DIALOG_EXPOSE_RTS_GBOOLEAN GtkWidget *widget, GdkEventExpose *event, gpointer user_data
#define GTK_CONVENTION_ENTRY_ACTIVATE_RTS_VOID GtkEditable *editable, gpointer user_data
#define GTK_CONVENTION_GTKENTRY_ACTIVATE_RTS_VOID GtkEntry *entry, gpointer user_data
#define GTK_CONVENTION_COMBO_CHANGED_RTS_VOID GtkComboBox *combo_box, gpointer user_data
#define GTK_CONVENTION_NOTEBOOK_RTS_VOID GtkNotebook *notebook, GtkNotebookPage *page, guint page_num, gpointer user_data
#define GTK_CONVENTION_ADJUSTMENT_RTS_VOID GtkAdjustment *adjustment, gpointer user_data
#define GTK_CONVENTION_TREEVIEW_RTS_VOID GtkTreeView *treeview, GtkTreePath *arg1, GtkTreeViewColumn *arg2, gpointer user_data
#define GTK_CONVENTION_TREEVIEW_CURSOR_CHANGED_RTS_VOID GtkTreeView *treeview, gpointer user_data
#define GTK_CONVENTION_TREEVIEW_ROW_EXPANDED_COLLAPSED_RTS_VOID GtkTreeView *treeview, GtkTreeIter *arg1,  GtkTreePath *arg2, gpointer user_data
#define GTK_CONVENTION_GTKOBJECT_RTS_VOID GtkObject *object, gpointer user_data
#define GTK_CONVENTION_BUTTON_PRESS_RTS_GBOOLEAN GtkWidget *widget, GdkEventButton *event, gpointer user_data
#define GTK_CONVENTION_ENTER_NOTIFY_RTS_GBOOLEAN GtkWidget *widget, GdkEventCrossing *event, gpointer user_data
#define GTK_CONVENTION_LEAVE_NOTIFY_RTS_GBOOLEAN GTK_CONVENTION_ENTER_NOTIFY_RTS_GBOOLEAN
#define GTK_CONVENTION_TREE_CELL_DATA_FUNC_RTS_VOID GtkTreeViewColumn *tree_column, GtkCellRenderer *cell, GtkTreeModel *tree_model, GtkTreeIter *iter, gpointer data
#define GTK_CONVENTION_GtkTreeIterCompareFunc_RTS_INT GtkTreeModel *model, GtkTreeIter *a, GtkTreeIter *b, gpointer user_data
#define GTK_CONVENTION_GtkTreeModelForeachFunc_RTS_GBOOLEAN GtkTreeModel *model, GtkTreePath *path, GtkTreeIter *iter, gpointer data
#define GTK_CONVENTION_GtkCellRendererText_RTS_VOID GtkCellRendererText *cell, gchar *path_string, gchar *new_text, gpointer user_data
#define GTK_CONVENTION_GFunc_RTS_VOID gpointer data, gpointer user_data
#define GTK_CONVENTION_GtkFileFilterFunc_RTS_BOOLEAN const GtkFileFilterInfo *filter_info, gpointer data

#define XPLAB_UTF_CONVERSION_ERROR  "UTF conversion error"
#define XPLAB_ASSN_KEY_0    "ASSN_KEY_0"                   /* associations */
#define XPLAB_ASSN_KEY_ROW  "ASSN_KEY_ROW"
#define XPLAB_ASSN_KEY_COL  "ASSN_KEY_COL"

#define DESC1_CANCEL_ACTION           "Cancel selection"
#define DESC2_CANCEL_ACTION           DESC1_CANCEL_ACTION
#define DESC1_STOP_ACTION             "Stop action"
#define DESC2_STOP_ACTION             "Any result is left undefined."
#define DESC1_TRAINING_PARSE_BUTTON   "Parse and train selected pattern"
#define DESC2_TRAINING_PARSE_BUTTON   "Selected patterns are highlighted in the image window."
#define DESC1_TRAINING_RESET_BUTTON   "Reset all user input in the mask"
#define DESC2_TRAINING_RESET_BUTTON   "Several keypresses switch forth and back."
#define DESC1_TRAINING_CLEAR_BUTTON   "Clear all user input in the mask"
#define DESC2_TRAINING_CLEAR_BUTTON   "Get back data with the reset-button."
#define DESC1_TRAINING_QUIT_BUTTON    "Quit training dialog."
#define DESC2_TRAINING_QUIT_BUTTON    "Trained data are not saved."
#define DESC1_TRAINING_SAVE_BUTTON    "Save trained data to disc"
#define DESC2_TRAINING_SAVE_BUTTON    "Session is saved."
#define DESC1_TRAINING_SAVE_QUIT_BUTTON "Save trained data and quit dialog."
#define DESC2_TRAINING_SAVE_QUIT_BUTTON "Trained data are saved."
#define DESC1_TRAINING_RB_SLIDER      "RB index"
#define DESC2_TRAINING_RB_SLIDER      "Focus is updated accordingly."
#define DESC1_TRAINING_FOCUS_SLIDER   "Diagonal focus size"
#define DESC2_TRAINING_FOCUS_SLIDER   "Focus is sized diagonal."
#define DESC1_TRAINING_PROPOSE_BUTTON "start/stop propose for focus"
#define DESC2_TRAINING_PROPOSE_BUTTON "Search for the best matching NB in current focus."
#define DESC1_TRAINING_TRACBLE_BUTTON "Highlight traceable NBs"
#define DESC2_TRAINING_TRACBLE_BUTTON "Not all kinds of NBs are tracable."
#define DESC1_TRAINING_PATTERN_ALL    "Considering all"
#define DESC2_TRAINING_PATTERN_ALL    "Traced patterns."
#define DESC1_TRAINING_PATTERN_SELECT "Select for training"
#define DESC2_TRAINING_PATTERN_SELECT "Regarding select-page."
#define DESC1_TRAINING_PATTERN_DESLCT "Deselect for training"
#define DESC2_TRAINING_PATTERN_DESLCT "Ignoring patterns."
#define DESC1_TRAINING_PATTERN_BACKWD "Select pattern backward"
#define DESC2_TRAINING_PATTERN_BACKWD "Parent pattern and child."
#define DESC1_TRAINING_PATTERN_FORWD  "Select pattern forward"
#define DESC2_TRAINING_PATTERN_FORWD  DESC2_TRAINING_PATTERN_BACKWD
#define DESC1_TRAINING_PATTERN_TRACE  "Trace in whole image"
#define DESC2_TRAINING_PATTERN_TRACE  "Constrained to selected class."
#define DESC1_TRAINING_PATTERN_TRACEF "Trace in focus"
#define DESC2_TRAINING_PATTERN_TRACEF DESC2_TRAINING_PATTERN_TRACE
#define DESC1_TRAINING_PATTERN_NB     "Denote pattern as a NB"
#define DESC2_TRAINING_PATTERN_NB     "NBs are treated as a single pattern."
#define DESC1_TRAINING_PATTERN_CNB    "Denote pattern as a CNB"
#define DESC2_TRAINING_PATTERN_CNB    "CNB consists of selected NNBs."
#define DESC1_TRAINING_PATTERN_NNB    "Denote pattern as a NNB"
#define DESC2_TRAINING_PATTERN_NNB    "Selected NNBs are trained as a CNB."
#define DESC1_TRAINING_PATTERN_NNBBWD "Search NNB in focus backward"
#define DESC2_TRAINING_PATTERN_NNBBWD "Highlighted patterns selected for training."
#define DESC1_TRAINING_PATTERN_NNBFWD "Search NNB in focus forward"
#define DESC2_TRAINING_PATTERN_NNBFWD DESC2_TRAINING_PATTERN_NNBBWD
#define DESC1_TRAINING_PATTERN_NBHOOD "Select neighborhood"
#define DESC2_TRAINING_PATTERN_NBHOOD "Default is 8-N (greedy)"
#define DESC1_CLUSTER_START           "Start clustering phase"
#define DESC2_CLUSTER_START           "A new database will be created."
#define DESC1_RECALL_START            "Start matching phase"
#define DESC2_RECALL_START            "The dump-button functionality is included."\
                                      " The contents of whatever is already in"   \
                                      " the window is removed."
#define DESC1_RECALL_DUMP             "Dump image tiles to disk"
#define DESC2_RECALL_DUMP             "The image is divided in tiles containing RB chains."
#define DESC1_REPLAY_START            "Start replay phase"
#define DESC2_REPLAY_START            "The results of the matching phase are included in "    \
                                      " the input file. The contents of whatever is already " \
                                      " in the window is removed."

#define DESC1_MAINTENANCE_TPS_CREATE  "Create empty TPS"
#define DESC2_MAINTENANCE_TPS_CREATE  "Required for training."
#define DESC1_MAINTENANCE_TPS_ERASE   "Erase TPS from DB"
#define DESC2_MAINTENANCE_TPS_ERASE   "The TPS is erased from DB completely."
#define DESC1_MAINTENANCE_CLS_ERASE   "Erase class list from TPS"
#define DESC2_MAINTENANCE_CLS_ERASE   "The class list is erased from the TPS."
#define DESC1_MAINTENANCE_CLS_CREATE  "Create empty class"
#define DESC2_MAINTENANCE_CLS_CREATE  "A class with default values is created and added to the class list."
#define DESC1_MAINTENANCE_CLS_SORT_NAME "Sort class list by name"
#define DESC2_MAINTENANCE_CLS_SORT_NAME "The class list is sorted in the DB."
#define DESC1_MAINTENANCE_CLS_SORT_TRANS "Sort class list by translation"
#define DESC2_MAINTENANCE_CLS_SORT_TRANS DESC2_MAINTENANCE_CLS_SORT_NAME
#define DESC1_MAINTENANCE_CSS_ERASE   "Erase class from class list"
#define DESC2_MAINTENANCE_CSS_ERASE   "The class is erased from the class list."
#define DESC1_MAINTENANCE_CSS_PASTE   "Paste from copy"
#define DESC2_MAINTENANCE_CSS_PASTE   "The internal buffer is pasted accordingly."
#define DESC1_MAINTENANCE_NBL_ERASE   "Erase NB list from class"
#define DESC2_MAINTENANCE_NBL_ERASE   "The NB list is erased from the class."
#define DESC1_MAINTENANCE_NBL_CREATE  "not available"
#define DESC2_MAINTENANCE_NBL_CREATE  "Subject for training."
#define DESC1_MAINTENANCE_NBL_PASTE   DESC1_MAINTENANCE_CSS_PASTE
#define DESC2_MAINTENANCE_NBL_PASTE   DESC2_MAINTENANCE_CSS_PASTE
#define DESC1_MAINTENANCE_NB_ERASE    "Erase NB and delete garbage in class list"
#define DESC2_MAINTENANCE_NB_ERASE    "Makes a whole class list investigation."
#define DESC1_MAINTENANCE_NB_COPY     "Copy NB for paste"
#define DESC2_MAINTENANCE_NB_COPY     "NB is copied to an internal buffer."
#define DESC1_MAINTENANCE_CNBL_ERASE  "Erase CNB list and delete garbage in class list"
#define DESC2_MAINTENANCE_CNBL_ERASE  DESC2_MAINTENANCE_NB_ERASE
#define DESC1_MAINTENANCE_CNB_ERASE   "Erase CNB and delete garbage in class list"
#define DESC2_MAINTENANCE_CNB_ERASE   DESC2_MAINTENANCE_NB_ERASE
#define DESC1_MAINTENANCE_NNBL_ERASE  "Erase NNB list and delete garbage in class list"
#define DESC2_MAINTENANCE_NNBL_ERASE  DESC2_MAINTENANCE_NB_ERASE
#define DESC1_MAINTENANCE_NNB_ERASE   "Erase NNB and delete garbage in class list"
#define DESC2_MAINTENANCE_NNB_ERASE   DESC2_MAINTENANCE_NB_ERASE
#define DESC1_MAINTENANCE_CCF_DUMP "Start/Stop CCF calculation"
#define DESC2_MAINTENANCE_CCF_DUMP "The CCF from various patterns is calculated and dumped."

#define XPLAB_RESPONSE_BROWSE 123

#define CTRL_FLOW_1        "glist_allocated_1"
#define CTRL_FLOW_2        "glist_allocated_2"
#define CTRL_FLOW_3        "glist_allocated_3"

#define TRAINING_WARNING_1  "WARNING: no input image\n"
#define TRAINING_WARNING_2  "WARNING: image file name undefined\n"
#define TRAINING_WARNING_3  "no binary image\n"
#define TRAINING_WARNING_4  "color not expected in phase\n"
#define TRAINING_WARNING_5  "no RBs in image\n"
#define TRAINING_WARNING_6  "WARNING: DB file name undefined\n"
#define TRAINING_WARNING_7  "WARNING: empty DB (use MAINTENANCE to create an empty TPS and then TRAINING)\n"
#define TRAINING_WARNING_8  "WARNING: TPS ID undefined\n"
#define TRAINING_WARNING_9  "WARNING: TPS ID unknown\n"
#define TRAINING_WARNING_10 "no trained class selected"
#define TRAINING_WARNING_11 "no traceable class selected"
#define TRAINING_WARNING_12 "WARNING: nothing to dump\n"
#define TRAINING_WARNING_13 "no traced patterns"
#define TRAINING_WARNING_14 "no trainable patterns"
#define TRAINING_WARNING_15 "WARNING: could not supersede old database by trained one\n"
#define TRAINING_INFO_1     "old database superseded by trained one, session dumped\n"

#define DIALOG_BUTTON_APPLY       "  apply "
#define DIALOG_BUTTON_CANCEL      " cancel "
#define DIALOG_BUTTON_CANCEL_BIG  "          cancel          "
#define DIALOG_BUTTON_COPY        "  copy  "
#define DIALOG_BUTTON_CREATE      " create "
#define DIALOG_BUTTON_DUMP        "  dump  "
#define DIALOG_BUTTON_ERASE       " erase  "
#define DIALOG_BUTTON_PASTE       " paste  "
#define DIALOG_BUTTON_QUIT        "  quit  "
#define DIALOG_BUTTON_REVERT      " revert "
#define DIALOG_BUTTON_SAVE        "  save  "
#define DIALOG_BUTTON_SAVE_QUIT   " save & quit "
#define DIALOG_BUTTON_SORT_NAME   " sort by name "
#define DIALOG_BUTTON_SORT_TRANS  " sort by translation "

#define SINGLE_BUTTON_CLEAR       " clear "
#define SINGLE_BUTTON_DEFAULT     " default "
#define SINGLE_BUTTON_DESELECT    " deselect "
#define SINGLE_BUTTON_DUMP        " dump "
#define SINGLE_BUTTON_FOCUS       " focus "
#define SINGLE_BUTTON_MATCHING    " matching "
#define SINGLE_BUTTON_NEW         " new "
#define SINGLE_BUTTON_REFRESH     " refresh "
#define SINGLE_BUTTON_REMOVE      " remove "
#define SINGLE_BUTTON_SELECT      " select "
#define SINGLE_BUTTON_START       " start "
#define SINGLE_BUTTON_STOP        " stop "

#define MENU_BUTTON_MAGN          "Magn"
#define MENU_BUTTON_ABOUT         "about"
#define MENU_BUTTON_EXIT          "exit"
#define MENU_BUTTON_EDIT          "edit"
#define MENU_BUTTON_DELETE        "delete"
#define MENU_BUTTON_FILE          "File"
#define MENU_BUTTON_HELP          "Help"
#define MENU_BUTTON_HISTORY       "History"
#define MENU_BUTTON_LOG           "log"
#define MENU_BUTTON_SAVE_EXIT     "save & exit"
#define MENU_BUTTON_TERMINOLOGY   "terminology"
#define MENU_BUTTON_TOOLS         "Tools"
#define MENU_BUTTON_TREE          "Tree"
